import 'package:dartweb/src/build_info.dart';

class DebuggingOptions {
	DebuggingOptions.enabled(
			this.buildInfo, {
				this.startPaused = false,
				this.disableServiceAuthCodes = false,
				this.dartFlags = '',
				this.enableSoftwareRendering = false,
				this.skiaDeterministicRendering = false,
				this.traceSkia = false,
				this.traceWhitelist,
				this.traceSystrace = false,
				this.endlessTraceBuffer = false,
				this.dumpSkpOnShaderCompilation = false,
				this.cacheSkSL = false,
				this.useTestFonts = false,
				this.verboseSystemLogs = false,
				this.hostVmServicePort,
				this.deviceVmServicePort,
				this.initializePlatform = true,
				this.hostname,
				this.port,
				this.webEnableExposeUrl,
				this.webUseSseForDebugProxy = true,
				this.webRunHeadless = false,
				this.webBrowserDebugPort,
				this.webEnableExpressionEvaluation = false,
				this.vmserviceOutFile,
				this.fastStart = false,
			}) : debuggingEnabled = true;

	DebuggingOptions.disabled(this.buildInfo, {
		this.initializePlatform = true,
		this.port,
		this.hostname,
		this.webEnableExposeUrl,
		this.webUseSseForDebugProxy = true,
		this.webRunHeadless = false,
		this.webBrowserDebugPort,
		this.cacheSkSL = false,
		this.traceWhitelist,
	}) : debuggingEnabled = false,
				useTestFonts = false,
				startPaused = false,
				dartFlags = '',
				disableServiceAuthCodes = false,
				enableSoftwareRendering = false,
				skiaDeterministicRendering = false,
				traceSkia = false,
				traceSystrace = false,
				endlessTraceBuffer = false,
				dumpSkpOnShaderCompilation = false,
				verboseSystemLogs = false,
				hostVmServicePort = null,
				deviceVmServicePort = null,
				vmserviceOutFile = null,
				fastStart = false,
				webEnableExpressionEvaluation = false;

	final bool debuggingEnabled;

	final BuildInfo buildInfo;
	final bool startPaused;
	final String dartFlags;
	final bool disableServiceAuthCodes;
	final bool enableSoftwareRendering;
	final bool skiaDeterministicRendering;
	final bool traceSkia;
	final String traceWhitelist;
	final bool traceSystrace;
	final bool endlessTraceBuffer;
	final bool dumpSkpOnShaderCompilation;
	final bool cacheSkSL;
	final bool useTestFonts;
	final bool verboseSystemLogs;
	/// Whether to invoke webOnlyInitializePlatform in Flutter for web.
	final bool initializePlatform;
	final int hostVmServicePort;
	final int deviceVmServicePort;
	final String port;
	final String hostname;
	final bool webEnableExposeUrl;
	final bool webUseSseForDebugProxy;

	/// Whether to run the browser in headless mode.
	///
	/// Some CI environments do not provide a display and fail to launch the
	/// browser with full graphics stack. Some browsers provide a special
	/// "headless" mode that runs the browser with no graphics.
	final bool webRunHeadless;

	/// The port the browser should use for its debugging protocol.
	final int webBrowserDebugPort;

	/// Enable expression evaluation for web target
	final bool webEnableExpressionEvaluation;

	/// A file where the vmservice URL should be written after the application is started.
	final String vmserviceOutFile;
	final bool fastStart;

	bool get hasObservatoryPort => hostVmServicePort != null;
}